// Sprocket Framework header file
// SprocketConstants.h


//	Resource IDs

enum
{
	kErrorAlertID						= 128,
	kStandardCloseAlertID				= 129,
	kStandardCloseWithNewPubsAlertID	= 130,
	kStandardYesNoAlertID				= 131,
	kErrorReporterAlertID				= 132,

	kCoreErrorStrings					= 128,
	kUnsupportedSystemSoftware			= 1,
	kNeedsThreadManager					= 2,
	kNeedsQuickdrawGX					= 3,

	kStandardCloseStrings				= 129,
	kQuittingStr						= 1,
	kClosingStr							= 2,

	kPreferencesFileStrings				= 130,
	kPreferencesFileName				= 1,

	kSplashPictureID					= 128,

	kCreditsBox							= 258
};


//	Key IDs

enum
{
	kHomeKey							= 1,
	kEnterKey							= 3,
	kEndKey								= 4,
	kHelpKey							= 5,
	kDeleteKey							= 8,
	kTabKey								= 9,
	kPageUpKey							= 11,
	kPageDownKey						= 12,
	kReturnKey							= 13,
	kLeftArrowKey						= 28,
	kRightArrowKey						= 29,
	kUpArrowKey							= 30,
	kDownArrowKey						= 31,
	kForwardDeleteKey					= 127
};


//	QuickDraw GX

#if		qUseQuickDrawGX
#define	kUseGraphicsSizeResource		0
#define	kAllowGXToExtendGraphicsHeap	((gxClientAttribute) 0)
#endif


//	Useful constants
	
enum
{
	kScrollbarWidth = 16,	//	width of a standard Macintosh scrollbar
	kScrollbarTweak = 2		//	left edge = rightedge - kScrollbarWidth + kScrollbarTweak
};


// Apple Grayscale Appearance Constants

// usage:	RGBColor myBackColor = {kAppleGrayscale2, kAppleGrayscale2, kAppleGrayscale2};
// or		myBackColor.red = myBackColor.blue = myBackColor.green = kAppleGrayscale2;

enum
{
	kAppleGrayscaleB	= 0,		// pure black
	kAppleGrayscaleW	= 65535,	// pure white
	kAppleGrayscale1	= 61166,
	kAppleGrayscale2	= 56797,	// preferred background gray
	kAppleGrayscale3	= 52428,
	kAppleGrayscale4	= 48059,
	kAppleGrayscale5	= 43690,
	kAppleGrayscale6	= 39321,
	kAppleGrayscale7	= 34952,
	kAppleGrayscale8	= 30853,
	kAppleGrayscale9	= 26214,
	kAppleGrayscale10	= 21845,
	kAppleGrayscale11	= 17476,
	kAppleGrayscale12	= 8738
};


// Sprocket AppleEvent Constants

enum
{
	kSprocketCommandClass	= ' SCC',
	kProcessOneCommand		= ' P1C'
};


// Sprocket Commands

enum
{
	cAbout				= 100,
	
	cNew				= 200,
	cOpen				= 201,
	cClose				= 202,
	cSave				= 203,
	cSaveAs				= 204,
	cPageSetup			= 205,
	cCustomPageSetup	= 206,
	cPrint				= 207,
	cPrintOne			= 208,
	cPreferences		= 209,
	cQuit				= 210,
	
	cRedo				= 299,
	cUndo				= 300,
	cCut				= 301,
	cCopy				= 302,
	cPaste				= 303,
	cClear				= 304,
	cSelectAll			= 305,
	cNewPublisher		= 306,
	cSubscribeTo		= 307,
	cPublishingOptions	= 308,
	cShowClipboard		= 309,
	
	cPlainText			= 401,
	cBold				= 402,
	cItalic				= 403,
	cUnderline			= 404,
	cOutline			= 405,
	cShadow				= 406,
	cCondensed			= 407,
	cExtended			= 408,
	
	cAlignDefault		= 450,
	cAlignLeft			= 451,
	cAlignCenter		= 452,
	cAlignRight			= 453,
	cAlignJustify		= 454,
	
	cOtherSize			= 500,
	c9Point				= 509,
	c10Point			= 510,
	c12Point			= 512,
	c14Point			= 514,
	c18Point			= 518,
	c24Point			= 524,
	c36Point			= 536,
	c48Point			= 548,
	c72Point			= 572,
	
	cOtherColor			= 600,
	cBlack				= 601,
	cBlue				= 602,
	cGreen				= 603,
	cRed				= 604,
	cPink				= 605,
	cOrange				= 606,
	cBrown				= 607
};
