/*

	File:		PreferencesDialogWindow.cp
	Project:	Sample code for Sprocket Framework 1.1 (DR2), released 6/15/96
	Contains:	A simple dialog window recipe
	To Do:		Whatever your heart desires

	Sprocket Major Contributors:
	----------------------------
	Dave Falkenburg, producer of Sprocket 1.0
	Bill Hayden,	 producer of Sprocket 1.1
	Steve Sisak,	 producer of the upcoming Sprocket 2.0
	
	Pete Alexander		Steve Falkenburg	Randy Thelen
	Eric Berdahl		Nitin Ganatra		Chris K. Thomas
	Marshall Clow		Dave Hershey		Leonard Rosenthal
	Tim Craycroft		Dave Mark			Dean Yu
	David denBoer		Gary Powell
	Cameron Esfahani	Jon Summers			Apple Computer, Inc.
		
	Comments, Additions, or Corrections:
	------------------------------------
	Bill Hayden, Nikol Software <nikol@codewell.com>

*/


#include "Sprocket.h" // for gHasAppleGuide
#include "MPPreferencesDialogWindow.h"
#include "UGuide.h"
#include "UDialog.h"


#if GENERATINGPOWERPC

#include "SpokenCommandHandler.h"

extern TSpokenCommandHandler*	SCH;

#endif



TMPPreferencesDialogWindow::TMPPreferencesDialogWindow() : TMultiPanelDialogWindow(kMPPreferencesDialogTemplateID)
{
}



void TMPPreferencesDialogWindow::ItemHit(short theItem)
{
	switch (theItem)
		{
		default:
			TMultiPanelDialogWindow::ItemHit(theItem);
			break;
		}
}




OSErr TMPPreferencesDialogWindow::IMultiPanelDialogWindow(short defaultPanel, short guideItem, short panelSelectorItem)
{
	OSErr	err;
	
	
	err = TMultiPanelDialogWindow::IMultiPanelDialogWindow(defaultPanel, guideItem, panelSelectorItem);
	
	if (err)
		return err;
	
	InitPanel(defaultPanel);
	
	return noErr;
}



void TMPPreferencesDialogWindow::InitPanel(short thePanel)
{
	switch(thePanel)
		{
		}
}


void TMPPreferencesDialogWindow::ClickInPanel(short thePanel, short /* theItem */)
{
	switch(thePanel)
		{
		}
}


void TMPPreferencesDialogWindow::ExitPanel(short thePanel)
{
	switch(thePanel)
		{
		}
}



void TMPPreferencesDialogWindow::AdjustMenusBeforeMenuSelection(void)
{
	gMenuBar->EnableCommand ( cCut,			true );
	gMenuBar->EnableCommand ( cCopy,		true );
	gMenuBar->EnableCommand ( cPaste,		true );
	gMenuBar->EnableCommand ( cClear,		true );
	gMenuBar->EnableCommand ( cSelectAll,	true );
}